/*
    AQTRONIX C++ Library
    Copyright 2003-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// IPRange.h: interface for the CIPRange class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IPRANGE_H__77D394C4_7F25_46A1_8318_BEFCA7FCBA5A__INCLUDED_)
#define AFX_IPRANGE_H__77D394C4_7F25_46A1_8318_BEFCA7FCBA5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IPAddress.h"

class CIPRange: public CObject 
{

protected:

	inline void OR(CIPAddress& IP1,CIPAddress& IP2, CIPAddress& IPResult);
	inline void AND(CIPAddress& IP1,CIPAddress& IP2, CIPAddress& IPResult);
	inline void XOR(CIPAddress& IP1,CIPAddress& IP2,CIPAddress& IPResult);
	CIPAddress StartIP;
	CIPAddress EndIP;
	CIPAddress SubnetMask;
	CIPAddress Max;

public:
	bool IsInRange(LPCTSTR IP);
	bool IsInRange(CIPAddress& IP);

	bool SetIPRange(CString IPRange);
	bool SetIPRange(CIPAddress& StartIP, CIPAddress& EndIP);
	static bool IsValidIPRange(CString &IP);
	static CString GetSubnetID(CString& IP, CString& CIDR);

	CString GetEndIP() const;
	CString GetStartIP() const;
	CString GetSubnetMask() const;
	CString ToString() const;

	CIPRange(CString IPRange);
	CIPRange(CIPAddress& StartIP, CIPAddress& EndIP);
	CIPRange();
	virtual ~CIPRange();

};

#endif // !defined(AFX_IPRANGE_H__77D394C4_7F25_46A1_8318_BEFCA7FCBA5A__INCLUDED_)
