'
'uninstall.vbs
'Script for removing WebKnight from an IIS server
'
Option Explicit

Dim HostName
Dim FilterName
Dim FilterDLLName

HostName = "LocalHost"				'uncomment this for unattended setup
FilterName = "WebKnight"
FilterDLLName = "WebKnight.dll"

Dim IISVersion
Dim UseNewInstaller
UseNewInstaller = False

IISVersion = GetIISVersion()
If IISVersion <> "" Then
    If IsNumeric(IISVersion) Then
        If IISVersion > 6 Then
            UseNewInstaller = True
        End If
    End If
End If

If UseNewInstaller Then
    UnInstallFilterIIS7Api FilterName
Else
    UnInstallFilterMetabase FilterName,HostName
End If

Sub UninstallFilterMetabase(FilterName,HostName)
    Dim Filters
    Dim Filter
    Dim LoadOrder

    'ask for hostname if we don't have one
    If HostName = "" Then
	    HostName = InputBox("Specify the IIS host from which you want to have " & FilterName & " uninstalled","Hostname required","LocalHost")
    End If
    If HostName <> "" Then 'user did not cancel?
	    'get list of installed filters
	    Set Filters = GetObject("IIS://" & HostName & "/W3SVC/Filters")
	    LoadOrder = Filters.FilterLoadOrder
	    If InStr(1,LoadOrder,FilterName)<1 Then
		    MsgBox "Filter is not installed on " & HostName,,FilterName
	    Else
    		
		    'remove filter from list
		    LoadOrder = Replace(LoadOrder,FilterName,"")
		    LoadOrder = Replace(LoadOrder,",,",",")
		    If Left(LoadOrder,1) = "," Then
			    LoadOrder = Mid(LoadOrder,2)
		    End If
		    If Right(LoadOrder,1) = "," Then
			    LoadOrder = Left(LoadOrder,Len(LoadOrder)-1)
		    End If
		    Filters.FilterLoadOrder = LoadOrder
		    Filters.SetInfo

		    'remove filter
		    Filters.Delete "IIsFilter",FilterName
    		
		    'notify user
		    MsgBox "You should restart IIS to completely remove " & FilterName & ".",,FilterName	
	    End If
    End If
End Sub

Sub UnInstallFilterIIS7Api(FilterName)
    'uninstall WebKnight using IIS7 API

    Dim AdminManager
    Dim IsapiFiltersSection
    Dim IsapiFiltersCollection
    Dim FilterElementPos

    Set AdminManager = CreateObject("Microsoft.ApplicationHost.WritableAdminManager")
    AdminManager.CommitPath = "MACHINE/WEBROOT/APPHOST"

    Set IsapiFiltersSection = AdminManager.GetAdminSection("system.webServer/isapiFilters", "MACHINE/WEBROOT/APPHOST")

    Set IsapiFiltersCollection = IsapiFiltersSection.Collection

    FilterElementPos = FindFilter(IsapiFiltersCollection,FilterName)
    If FilterElementPos>-1 Then
        IsapiFiltersCollection.DeleteElement(FilterElementPos)
    End If


    AdminManager.CommitChanges()
    
    'notify user
    MsgBox "You should restart IIS to completely remove " & FilterName & ".",,FilterName	

    Set IsapiFiltersCollection = Nothing
    Set IsapiFiltersSection = Nothing
    Set AdminManager = Nothing
End Sub

Function FindFilter(Collection,FilterName)
    Dim element
    Dim i
    Dim count
    FindFilter = -1
    count = CLng(Collection.Count)
    For i=0 To count - 1
	Set element = collection.Item(i)
	If LCase(element.Name) = "filter" Then
		Dim n
		Set n = element.GetPropertyByName("name")
		If n.Value = FilterName Then
			FindFilter = i
		End If
        End If
    Next
End Function

Function GetIISVersion
    Dim oShell
    Dim v
    v = ""
    
    On Error Resume Next
    Set oShell = CreateObject("WScript.Shell")
    v = oShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\InetStp\MajorVersion")
    On Error Goto 0
    Set oShell = Nothing

    GetIISVersion = v
End Function
